#!/usr/bin/env python3
import re
import itertools
from mpmath import mp

mp.dps = 1000

p = {10:[0.75,0.80,0.85],11:[0.75,0.80,0.85],12:[0.80,0.85,0.90],16:[0.85,0.90,0.95]}
l = 50
n = 4
for w in [10,11,12,16]:
    for pv in (p[w]):
        with open("experiments/_n"+str(n)+"_w"+str(w)+"_s"+str(2*w)+"_l"+str(l)+"_bernoulli_python_maxima.txt") as fi:
            for li in fi:
                # extract the seed from the python like array
                li = re.sub('[\'\"\[\]]', '', li)            
                e = li.split(' ')
                # extract each individual seed and ...
                seeds_array = e[0].split('_')
                # extract the range until the current set of seeds is better
                seeds_pmax  = float(e[1])
                
                if seeds_pmax >= pv:
                    # first set of seed to be in the right range
                    print("w:"+str(w)+"\tpv:"+str(pv),end='')
                    
                    # search for the seed and all its possible normalizations (reverse all seeds, permut all of them) to get a correct equality
                    seeds_array_rev = list()
                    for e in seeds_array:
                        seeds_array_rev.append(e[::-1])
                    seeds_permut        = list(itertools.permutations(seeds_array))
                    seeds_permut.extend ( list(itertools.permutations(seeds_array_rev)))
                                        
                    # find the corresponding polynomial in the ied file
                    with open("experiments/_n"+str(n)+"_w"+str(w)+"_s"+str(2*w)+"_l"+str(l)+".ied") as fpi:
                        for lpi in fpi:
                            # check each permutation
                            for seeds_set in seeds_permut:
                                seeds = ",".join(seeds_set)
                                if lpi.startswith(seeds):
                                    lpi_array  = lpi.split('\t')
                                    lpi_poly   = lpi_array[4].split(';')
                                    # Sensitivity computation starts here :
                                    prob_value = mp.mpf(0.0)
                                    for lpi_e in lpi_poly:
                                        if len(lpi_e) > 3:
                                            m = re.search(r'(\d+)\,(\d+)=(\d+)', lpi_e)
                                            pow_val = int(m.group(1))
                                            set_val = int(m.group(2))
                                            cnt_val = int(m.group(3))
                                            if set_val == 1:
                                                prob_value += mp.mpf(cnt_val) * (mp.mpf(pv) ** pow_val) * ((1.0 - mp.mpf(pv)) ** (l - pow_val))
                                    print('\tPr:%2.4f' % float(prob_value*100))
                        break
